Subject: Re: bug#33285: Installing, then removing, a package yields a different profile

From: Chris Marusich <[email-masked]>
Date: Fri, 08 Feb 2019 19:44:33 -0800

Jelle Licht <[email-masked]> writes:

> Ricardo Wurmus <[email-masked]> writes:
>
>> [snip]
>>
>> I think it’s fine to leave it as it is, then.  “--install” and
>> “--remove” are stateful and should be expected to have quirks like this.
>> (E.g. upgrading Guix in between two “--install”s can lead to
>> a mosaic of a profile that could not be produced any other way.)
>
> This seems like a very reasonable perspective on this issue, so I
> concur. Should we state this explicitly somewhere in the manual?

Thinking about it that way, I agree it makes sense as is.  I think it's
valid to say this isn't a bug, then.  I've confirmed that "adding" and
then "removing" a package by using a stateless method (e.g., the "guix
package -m" method) results in the expected behavior: the first and
third profile generations refer to exactly the same profile:

--8<---------------cut here---------------start------------->8---
$ ls -al /tmp/test-profile*
lrwxrwxrwx 1 marusich users 19 Feb  8 19:39 /tmp/test-profile -> test-profile-3-link
lrwxrwxrwx 1 marusich users 51 Feb  8 19:39 /tmp/test-profile-1-link -> /gnu/store/7j6gy2xvyz7zzpccwsssbxxzykv6q0zg-profile
lrwxrwxrwx 1 marusich users 51 Feb  8 19:39 /tmp/test-profile-2-link -> /gnu/store/yz9qskdl926mdy1i63yzsqwhcciswv90-profile
lrwxrwxrwx 1 marusich users 51 Feb  8 19:39 /tmp/test-profile-3-link -> /gnu/store/7j6gy2xvyz7zzpccwsssbxxzykv6q0zg-profile
--8<---------------cut here---------------end--------------->8---

I'm satisfied.  I'm honestly not sure it's worth mentioning in the
manual.  I feel like explaining it would add little value and just
clutter up the documentation.  This was mainly a curiosity for me.

-- 
Chris